mod Ul01 logic: 'cl'

incl Mtex

loc rem 
  \para \bf  PREMIOVA ULOHA Z PREDMETU 1-AIN-470 SPECIFIKACIA A VERIFIKACIA 
  PROGRAMOV  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.19 
  \para* \it  Datum:  \end streda 9.4.2008 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-AIN-470-svp/0708ls/?lang=sk 
  \para* \it  Kontakt:  \end Jan.Komara(at)fmph.uniba.sk 

loc rem 
  \para \bf  Uvodna poznamka.  \end Zadanie sa sklada z tychto suborov: 
  \items 
   \item \para Subory \it  mtex*.cl  \end obsahuju makra pre CL-TeX. 
   \item \para Subor \it  ul*.cl  \end obsahuje priklady, ktore mate vyriesit v 
         tejto premiovej ulohe. 
  \end
  \para Tieto subory sa musia skompilovat v spravnom poradi; presny postup je 
  uvedeny v subore \it  readme.txt  \end. 

loc rem 
  \para \bf  Hodnotenie.  \end 
  \items 
   \item \para Pocet bodov za ulohu: \bf  \it  5  \end  \end. 
   \item \para Hodnoti sa len kompletne vyriesena uloha. 
   \item \para Ulohy rieste \bf  \it  samostatne!  \end  \end 
  \end
  \para Ulohu treba odovzdat do 21.4.2008 (pondelok) do 14:00. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  [CL] CL-TeX.  \end 

appldisp/1 Tex_f1_r
  Std('r',0)

appldisp/2 Tex_f2_r1
  Std('r1',0)

rem 
  \para \bf  Generalized root I.  \end 

theory Generalized_root1

fun F 'Tex_f1_f'

axiom Zero
  F(0) = 0

axiom Unbounded
  \e y x < F(y)

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    \e y(F(y) <= x & x < F(y+1))
  \end

thm Existence
  \e y(F(y) <= x & x < F(y+1))

end theory Generalized_root1

rem 
  \para \bf  Generalized root II.  \end 

theory Generalized_root2

fun F 'Tex_f1_f'

fun G 'Tex_f1_g'

axiom Zero
  F(0) = 0

axiom Unbounded
  x < F G(x)

fun/2 R1 'Tex_f2_r1'
  R1(0,x) = 0
  R1(y+1,x) = y <- F(y) <= x
  R1(y+1,x) = R1(y,x) <- F(y) > x

fun R 'Tex_f1_r'
  R(x) = R1(G(x),x)

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    F R(x) <= x & x < F(R(x)+1)
  \end

thm Specification
  F R(x) <= x & x < F(R(x)+1)

end theory Generalized_root2

rem 
  \para \bf  Generalized root III.  \end 

theory Generalized_root3

fun F 'Tex_f1_f'

fun G 'Tex_f1_g'

axiom Zero
  F(0) = 0

axiom Unbounded
  x < F G(x)

fun/2 R1 'Tex_f2_r1'
  R1(y,x) = y <- x < F(y+1)
  R1(y,x) = R1(y+1,x) <- x >= F(y+1) & y < G(x)

fun R 'Tex_f1_r'
  R(x) = R1(0,x)

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    F R(x) <= x & x < F(R(x)+1)
  \end

thm Specification
  F R(x) <= x & x < F(R(x)+1)

end theory Generalized_root3

